//
//  SoxView.h
//  Sox Wrap
//
//  Created by Kenneth Hoffmann on 11/7/04.
//  Copyright 2004 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>

@class TaskWrap;
@interface SoxView : NSObject {
	NSMutableArray * inputFormatOptions;
	NSMutableArray * outputFormatOptions;
	NSMutableArray * inputFiles;
	NSMutableArray * outputFiles;
	NSString * outputPath;
	
	NSUserDefaults * defaults;
	int globalCounter;
	
	IBOutlet NSTableView * inputTable;
	IBOutlet NSPopUpButton * fromFormat;
	IBOutlet NSPopUpButton * toFormat;
	IBOutlet NSPopUpButton * fromDataEncoding;
	IBOutlet NSPopUpButton * toDataEncoding;
	IBOutlet NSPopUpButton * fromDataSize;
	IBOutlet NSPopUpButton * toDataSize;
	IBOutlet NSTextField * volume;
	IBOutlet NSPopUpButton * channels;
	IBOutlet NSTextField * fromSampleRate;
	IBOutlet NSTextField * toSampleRate;
	IBOutlet NSButton * fromSampleRateSwitch;
	IBOutlet NSButton * toSampleRateSwitch;
	
	IBOutlet NSButton * runButton;
	IBOutlet NSButton * cancelButton;
	IBOutlet NSButton * verboseSwitch;
	IBOutlet NSProgressIndicator * progressBar;
	
	IBOutlet NSTextField * outputPathLine;
	IBOutlet NSButton * changeOutputButton;
	
	IBOutlet NSTextView * textBox;
	IBOutlet TaskWrap * taskWrap;
}

-(IBAction)runSox:(id)sender;
-(IBAction)cancelTask:(id)sender;
-(void)finishTask;
-(void)continueTask;

-(void)fillInputFormatOptions;
-(void)fillOutputFormatOptions;
-(void)fillOutputFiles;

-(NSString *)resolveFromFormat;
-(NSString *)resolveToFormat;
-(NSString *)resolveFromDataEncoding;
-(NSString *)resolveToDataEncoding;
-(NSString *)resolveFromDataSize;
-(NSString *)resolveToDataSize;
-(NSString *)resolveChannels;

-(void)checkOverwrite;
-(IBAction)changeOutputPath:(id)sender;
-(void)changeButtonStates;
-(BOOL)isVerbose;
-(IBAction)toggleFromSampleRate:(id)sender;
-(IBAction)toggleToSampleRate:(id)sender;

	///TABLE
-(IBAction)addFile:(id)sender;
-(IBAction)removeFile:(id)sender;
-(void)addFilesToArray:(NSArray *)new;
-(void)scanDirectory:(NSString *)path;

@end
